/*! \file anamodsalsamodules.h \ingroup functions
  \brief Prototypes for using the standard modules
 */
#ifndef NMDMODULES_H
#define NMDMODULES_H

#include "petsc.h"

extern PetscErrorCode RegisterSimpleModules(void);
extern PetscErrorCode DeRegisterSimpleModules(void);

extern PetscErrorCode RegisterVarianceModules(void);
extern PetscErrorCode DeRegisterVarianceModules(void);

extern PetscErrorCode RegisterNormalityModules(void);
extern PetscErrorCode CommutatorNormFAllowSqrtTimes(int n);

extern PetscErrorCode RegisterStructureModules(void);
extern PetscErrorCode DeRegisterStructureModules(void);

extern PetscErrorCode RegisterSpectrumModules(void);
extern PetscErrorCode DeregisterSpectrumModules(void);
extern PetscErrorCode SpectrumComputePreconditionedSpectrum(void);
extern PetscErrorCode SpectrumComputeUnpreconditionedSpectrum(void);

extern PetscErrorCode RegisterJPLModules(void);
extern PetscErrorCode RegisterIprsModules(void);

extern PetscErrorCode AnaModRegisterSalsaModules(void);
extern PetscErrorCode AnaModDeregisterSalsaModules(void);

PetscErrorCode RegisterLapackModules();
/*
 * Variance
 */
#define DIAGONAL_POSITIVE     2
#define DIAGONAL_NONNEGATIVE  1
#define DIAGONAL_INDEFINITE   0
#define DIAGONAL_NONPOSITIVE -1
#define DIAGONAL_NEGATIVE    -2
#define DIAGONAL_ZERO        10
#define DIAGONAL_INDEFINITE_WITH_ZEROS 11

#endif
