/*! \file anamodtypes.h \anchor types 
  \ingroup implementation

  This file lists the possible return types of analysis modules.
  See \ref typehandling about semantic issues.
*/
#ifndef MODULE_TYPES_H
#define MODULE_TYPES_H

typedef void* AnaModNumericalProblem;
typedef union
{
  int i,len;
  double r;
  int *ii;
  double *rr;
  char *c;
} AnalysisItem ;
typedef struct IntArray_ *IntArray;
typedef struct StringArray_ *StringArray;
typedef struct AnalysisItemArray_ *AnalysisItemArray;
typedef struct AnalysisDataTypeArray_ *AnalysisDataTypeArray;

#if defined(HAVE_NMD)

#include "nmd.h"
typedef NMDDataType AnalysisDataType;

/*
#define ANALYSISNONE NONE
*/
#define ANALYSISINTEGER NMDInt
#define ANALYSISDOUBLE NMDReal
#define ANALYSISFLOAT NMDReal
#define ANALYSISSTRING NMDString
/*
#define ANALYSISMETA META
#define ANALYSISVOID VOID
*/
#define ANALYSISINTARRAY NMDIntarray
#define ANALYSISDBLARRAY NMDRealarray
#define ANALYSISFLARRAY NMDRealarray

#else

typedef int AnalysisDataType;

#define ANALYSISNONE 1
#define ANALYSISSTRING 2
#define ANALYSISINTEGER 3
#define ANALYSISDOUBLE 4
#define ANALYSISFLOAT 5
#define ANALYSISMETA 6
#define ANALYSISVOID 7
#define ANALYSISINTARRAY 8
#define ANALYSISDBLARRAY 9
#define ANALYSISFLARRAY 10

#endif

#endif
