#ifndef NMD_IMPL_H
#define NMD_IMPL_H 1

#include "nmd.h"

#if !defined(NMD_HAVE_PETSC)
#define CHKMEMQ
#endif

struct NMD_metadata_item_ {
  int cookie;
  char *name; NMDDataType t; NMDTruth set;
  int i;
  double r;
  struct NMD_intarray_struct *ii;
  struct NMD_realarray_struct *rr;
  char *cc;
};

struct NMD_metadata_category_ {
  int cookie;
  char *name;
  int alloc,ncmp;
  NMD_metadata_item* cmps;
};

struct NMD_metadata_ {
  int cookie;
  int alloc,ncat;
  NMD_metadata_category* cats;
};

/*
 * this object should be the union of the above, in the sense
 * that it can be cast to/from all of them;
 * it is not actually used
 */
struct NMD_object_ {
  int cookie;
};

struct NMD_intarray_struct {
  int length,unique;
  int *data;
};

struct NMD_realarray_struct {
  int length,unique;
  NMDRealtype *data;
};

#endif

