#ifndef LINEAR_IMPL_H
#define LINEAR_IMPL_H

#include "petscmat.h"
#include "petscvec.h"
#include "petscksp.h"
#include "nmd.h"
#include "syspro_impl.h"

#define LINSYSCOOKIE 3297
#define LINSOLCOOKIE 3298
#define SYSPROCHECKVALIDLINSYS(i) {SYSPROCHECKVALID(i,LINSYSCOOKIE,"linear system");}
#define SYSPROCHECKVALIDLINSYSa(i,a) {SYSPROCHECKVALIDa(i,LINSYSCOOKIE,"linear system",a);}
#define SYSPROCHECKVALIDLINSOL(i) {SYSPROCHECKVALID(i,LINSOLCOOKIE,"linear solution");}
#define SYSPROCHECKVALIDLINSOLa(i,a) {SYSPROCHECKVALIDa(i,LINSOLCOOKIE,"linear solution",a);}

#define ALLPARTSNEW (1+2+4+8+16)
struct LinearSystem_ {
  NUMERICALPROBLEMHEADER
  int cookie;
  int partsoriginal;
  Mat A,B; Vec Rhs,Sol,Init,Tmp;
  PetscTruth known_solution;
  NMD_metadata metadata;
} ;

struct LinearSolution_ {
  int cookie;
  Vec Out;
  NMD_metadata statistics;
  /*
  PetscTruth abort;
  PetscLogDouble tpreprocess,tsetup,tsolve;
  KSPConvergedReason converged;
  int iterations;
  */
  void *ctx;
} ;

#endif
